<?php include("bee/compiler.php"); return; ?>
<script language="bee">

/************************************************************
 *	dbobj: Database Object
 *
 *	arg%table = the table name (default is the object name {arg%this})
 *
 *	Object variables:
 *	%matrix		the name of the matrix used.  Default "matrix"
 *	%dbid		the dbid.  Default ""
 *	%status		the status of last database operation
 *	%message	the message of last database operation
 *
 *	All other object variables are "inherited" from the database command
 ************************************************************/

function dbobj
{
	// Parameters can be reloaded
	if ({#this%table:} == 0) var this%table = "{arg%table}";
	if ({#this%table:} == 0) var this%table = "{arg%this}";
	if ({#this%matrix:} == 0) var this%matrix = "{arg%this}_matrix";
	if ({#this%dbid:} == 0) var this%dbid = "{arg%dbid}";

	var this%status = 0;
	var this%message = "";
	
	var this%function:query = "dbobj_query";
	var this%function:select = "dbobj_action";
	var this%function:update = "dbobj_action";
	var this%function:insert = "dbobj_action";
	var this%function:delete = "dbobj_action";
	var this%function:nextseq = "dbobj_nextseq";
	var this%function:new = "dbobj_dbtact";
	var this%function:load = "dbobj_dbtact";
	var this%function:unload = "dbobj_dbtact";
	var this%function:store = "dbobj_dbtact";
	var this%function:restore = "dbobj_dbtact";
	var this%function:showcreatetable = "dbobj_dbtact";
	var this%function:showinsertinto = "dbobj_dbtact";
	var this%function:showinsertintos = "dbobj_dbtact";
	var this%function:group = "dbobj_group";
	var this%function:menu = "dbobj_menu";
	var this%function:matrixdump = "dbobj_matrix_dump";
	var this%function:dump = "dbobj_dump";
}


/************************************************************
 *	dbobj_query: Send a query to the database
 *
 *	arg%query (default) = the query string
 *	arg%seek = the seek parameter for the database command
 ************************************************************/

function dbobj_query
{
	//parent "{arg%this}%";
	if ({#arg%function:query} > 0) var param%database:query = "{arg%function:query}";
	if ({#arg%function:seek} > 0) var param%database:seek = "{arg%function:seek}";
	database this dbid="{this%dbid}";
	//database this query="{arg%query}" dbid="{this%dbid}";

	//var session%{arg%this} = "(var)session%this";
	//var this%status = "{status%database}";
	//var this%message = "{message%database}";
}


/************************************************************
 *	dbobj_action: Called via dbobj%select, dbobj%update, dbobj%insert, dbobj%delete
 *		to carry out the corresponding database command
 *
 *	arg%thisfunction = the action parameter for the database command
 *	arg%seek = the seek parameter for the database command
 *	arg%matrix = the matrix used in this database command (default is {this%matrix})
 ************************************************************/

function dbobj_action
{
	matrix = "{arg%matrix}";
	if ({#matrix:} == 0) matrix = "{this%matrix}";
	//parent "{arg%this}%";
	parent "{matrix}%";
	if ({#arg%function:seek} > 0) var param%database:seek = "{arg%function:seek}";
	database this matrix="{this%matrix}" action="{arg%function:trial|?:'@value',!}{arg%thisfunction}" dbid="{this%dbid}";
	//var session%{arg%this} = "(var)session%this";
	//var this%status = "{status%database}";
	//var this%message = "{message%database}";
}


/************************************************************
 *	dbobj_nextseq: Return the result of the nextseq for {arg%seq}
 *
 *	arg%seq = the sequence name
 ************************************************************/

function dbobj_nextseq
{
	database this action="nextseq:{arg%seq}" dbid="{this%dbid}";
	result%function = "{this%lastseq}";
}


/************************************************************
 *	dbobj_dbtact: Called via dbobj%new, dbobj%load, dbobj%unload, dbobj%store, dbobj%restore
 *		to carry out the corresponding dbtree command
 *
 *	arg%function:this = the name of the dbtree object in the calling statement
 *	arg%thisfunction = the action parameter for the database command
 ************************************************************/

function dbobj_dbtact
{
	parent {arg%function:this}%;
	database "{arg%function:this}" name="{this%name}" action="{arg%thisfunction}" dbid="{this%dbid}";
}


/************************************************************
 *	dbobj_group: Perform the "group" command on the specified
 *		variable into the class specified by this%matrix and
 *		set the group result into the object.
 *
 *	arg%group (default) = the variable to be grouped.
 *	arg%delim = the "delim" parameter for group
 *	arg%inverse = the "inverse" parameter for group
 *	If this%matrix is blank, set it to {arg%this}_matrix
 ************************************************************/

function dbobj_group
{
	//var gvar = "{arg%{arg%thisfunction}}";
	//if ({#gvar:} == 0) return;
	//parent "{gvar}";
	var gvar = "arg%arg";
	if ({#{gvar}} == 1)
	{
		// It is a variable name
		var gvar = "{arg%arg}";
		if ({#gvar:} == 0) return;
		parent "{gvar}";
	}

	if ({#this%matrix} == 0) var this%matrix = "{arg%this}_matrix";

	// The "group" command always operates in the local context.
	// Needs to link the variables it changes to the parent.
	parent "{arg%this}%";
	parent "{this%matrix}%";
	if ({#arg%function:delim} > 0) var param%group:delim = "{arg%function:delim}";
	if ({#arg%function:inverse} > 0) var param%group:inverse = "{arg%function:inverse}";
	group "{gvar}" matrix="{this%matrix}" result="{arg%this}";
}

include "common/dbobj_dump.bs";
include "common/dbobj_menu.bs";
</script>