<?php include("bee/compiler.php"); return; ?>
<script language="bee">

/************************************************************
 *	beeselect: Display a select tag based on a list or a db result
 *
 *	value = a value tested for "selected"
 *	optionlist = an array with option values => label.
 *	If optionlist contains no elements
 *		dbname = a database result name with the optionlist
 *		dbopvalue = the expression used as the option value (use "{op:...}")
 *		dboplabel = the expression used as the option label (use "{op:...}")
 *	Other arguments are used in the <select> tag.
 ************************************************************/

function select
{
	var optionlist = (var)arg%optionlist;
	if ({#optionlist} == 0)
	{
		if ('{arg%dbname}')
		{
			parent {arg%dbname}%;
			foreach ((db){arg%dbname} as op)
				var optionlist = (var)optionlist convert="merge:(array){arg%dbopvalue}=>'{arg%dboplabel}'";
		}
	}
	foreach (optionlist)
	{
		if ('{foreach|escape:quote}' == '')
			var optionlist:{foreach:key} = {foreach:key};
	}

	clear arg%function:function;
	clear arg%function:value;
	clear arg%function:optionlist;
	clear arg%function:dbname;
	clear arg%function:dbopvalue;
	clear arg%function:dboplabel;

	if ({arg%function:namesuffix|isset} > 0)
	{
		var arg%function:name = {arg%function:name}{arg%function:namesuffix};
		clear arg%function:namesuffix;
	}
	
	var gotselected = 0;
	var result%function:value = "";
	var result%function:label = "";
	display "<select ";
	display "(var)arg%function" convert='list:(@key="@value") ()';
	display ">\n";

	foreach (optionlist)
	{
		var selected = "";
		if ({arg%value|isset} > 0 && '{arg%value}' == '{foreach:key}')
		{
			var selected = " selected";
			var gotselected = 1;
			var result%function:value = "{foreach:key}";
			var result%function:label = "{foreach}";
		}
		display '<option value="{foreach:key|unescape}"{selected}>{foreach}</option>\n';
	}
	if ({arg%value|isset} > 0 && {gotselected} == 0)
	{
		display '<option value="{arg%value|unescape}" selected>{arg%value}</option>\n';
		var result%function:value = "{arg%value}";
		var result%function:label = "{arg%value}";
	}
	display "</select>\n";
}


/************************************************************
 *	beeradio: Display a series of radio tag based on a list or a db result
 *
 *	value = a value tested for "checked"
 *	optionlist = an array with option values => label.
 *	If optionlist contains no elements
 *		dbname = a database result name with the optionlist
 *		dbopvalue = the expression used as the option value (use "{op:...}")
 *		dboplabel = the expression used as the option label (use "{op:...}")
 *	Other arguments are used in the <input type=radio ...> tag.
 ************************************************************/

function radio
{
	var optionlist = (var)arg%optionlist;
	if ({#optionlist} == 0)
	{
		if ('{arg%dbname}')
		{
			foreach ((db){arg%dbname} as op)
				var optionlist = (var)optionlist convert="merge:(array){arg%dbopvalue}=>'{arg%dboplabel}'";
		}
	}
	foreach (optionlist)
	{
		if ('{foreach|escape:quote}' == '')
			var optionlist:{foreach:key} = {foreach:key};
	}

	clear arg%function:function;
	clear arg%function:value;
	clear arg%function:optionlist;
	clear arg%function:dbname;
	clear arg%function:dbopvalue;
	clear arg%function:dboplabel;

	if ({arg%function:namesuffix|isset} > 0)
	{
		var arg%function:name = {arg%function:name}{arg%function:namesuffix};
		clear arg%function:namesuffix;
	}

	var gotchecked = 0;
	var result%function:value = "";
	var result%function:label = "";

	foreach (optionlist)
	{
		var checked = "";
		if ({arg%value|isset} > 0 && '{arg%value}' == '{foreach:key}')
		{
			var checked = " checked";
			var gotchecked = 1;
			var result%function:value = "{foreach:key}";
			var result%function:label = "{foreach}";
		}
		display "<input type=radio ";
		display "(var)arg%function" convert='list:(@key="@value") ()';
		display ' value="{foreach:key}"{checked}>{foreach}\n';
	}
	if ({arg%value|isset} > 0 && {gotchecked} == 0)
	{
		display "<input type=radio ";
		display "(var)arg%function" convert='list:(@key="@value") ()';
		display ' value="{arg%value}" checked>{arg%value}\n';
		var result%function:value = "{arg%value}";
		var result%function:label = "{arg%value}";
	}
}


/************************************************************
 *	beeformentry: Display a form entry tag based on the specification in the formclass variables
 *
 *	formclass = the name of the formclass
 *	field = the name of the entry field
 *	Other arguments are used in the entry tag.
 ************************************************************/

function formentry
{
	if ('{arg%formclass}' == '' || '{arg%field}' == '')
		return status=1 message="Either form or field is missing";

	var field = {arg%field};
	global "{arg%formclass}%Field";
	global "{arg%formclass}%{field}";
	var fldrec = "(array){{arg%formclass}%Field:{field}|escape:quotes}";
	
	var caption = (var)fldrec convert=shift;
	if ('{caption|escape:quotes}' == '')
		var caption = {field|words};
	
	var type = (var)fldrec convert=shift;
	var width = (var)fldrec convert=shift;
	var height = (var)fldrec convert=shift;
	var args = (var)fldrec convert=list:(@value),();
	var data = "";
	var optionlist = "";
	
	clear arg%function:function;
	clear arg%function:formclass;
	clear arg%function:field;

	output bufferbegin;
	if ('{type}' == 'hidden')
	{
		var caption = "";
		display '<input type="hidden" name="{field}" value="{arg%value}">\n';
	} elseif ('{type}' != 'caption')
	{
		var extraArgs = (var){arg%formclass}%{field};
		var extraArgs = (var)extraArgs convert=merge:(var)arg%function;
		if ('{type}' == 'select' || '{type}' == 'enum')
		{
			global "param%select";
			var param%select = (var)arg%function convert=merge:(var)extraArgs;
			var optionlist = (var)param%select:optionlist;
			select name={field};
			var data = {result%select:label};
		} elseif ('{type}' == 'radio')
		{
			global "param%radio";
			var param%radio = (var)arg%function convert=merge:(var)extraArgs;
			var optionlist = (var)param%radio:optionlist;
			radio name={field};
			var data = {result%radio:label};
		} else
		{
			if ({extraArgs:namesuffix|isset} > 0)
			{
				var field = {field}{extraArgs:namesuffix};
				clear extraArgs:namesuffix;
			}
			clear extraArgs:value;
			var extraArgList = (var)extraArgs convert="list:(@key=\"@value\") ()"];
			var extraArgList = " {extraArgList}" convert="if:'{#extraArgList}'> 0";

			if ('{height}' != '' && '{height}' > 1)
				display '<textarea name="{field}" cols="{width}" rows="{height}"{extraArgList}>{arg%value}</textarea>\n';
			else
				display '<input type="text" name="{field}" size="{width}"{extraArgList} value="{arg%value}">\n';

			var data = {arg%value};
		}
	}
	var tag = {sys%output:content} convert=trim;
	output buffercancel;
	
	
	var result%function = "(array)
		tag=>'{tag}',
		data=>'{data}',
		caption=>'{caption|escape:quotes}',
		type=>'{type}',
		width=>'{width}',
		height=>'{height}',
		args=>'{args|escape:quotes}'";
	
	var result%function:optionlist = (var)optionlist;
}
</script>
