<?php include("bee/compiler.php"); return; ?>
<script language="bee">

/************************************************************
 *	xml_getnode: Return the contents of the node
 *
 *	arg%node - the node index
 *	result%function - node contents indexed by names
 *		(e.g. tag, type, value, namespace, localpart and prefix)
 ************************************************************/

function xml_getnode
{
	if ({arg%function:node|isset} == 0) return status=1 message="Argument 'node' is missing";
	if ({this%xml_{arg%node}|isset}) var result%function = "(var)this%xml_{arg%node}";
}


/************************************************************
 *	xml_getnodelist: Get all node indexes under {arg%node} including itself
 *		or all nodes if {arg%node} is not set.
 *
 *	arg%node - the node index (default is all nodes)
 *	result%function - node indexes of the subtree including {arg%node}
 ************************************************************/

function xml_getnodelist
{
	//if ({#arg%node:} == 0) var arg%node = "{this%root}";
	// Cannot get subtree from root because the closing tag is at the same level
	if ({arg%function:node|isset} == 0) {
		this%tree_getallnodes;
		if ({status%tree_getallnodes})
			return status="{status%tree_getallnodes}" message="{message%tree_getallnodes}";
		var result%function = "(var)result%tree_getallnodes";
		clear result%function:{this%root};  // The root is dummy
		return;
	}
	this%tree_descendants node="{arg%node}";
	var result%function = "(var)result%tree_descendants";
}


/************************************************************
 *	xml_getattr: Get attribute contents for attribute {arg%attr}
 *		of node {arg%node}
 *
 *	arg%node - the node index
 *	arg%attr - the attribute name (literally as specified in the XML Doc)
 *	result%function - attribute contents indexed by name
 *		(i.e. value, namespace, localpart and prefix)
 ************************************************************/

function xml_getattr
{
	if ({arg%function:node|isset} == 0) return status=1 message="Argument 'node' missing";
	if ({#arg%attr:} == 0) return status=1 message="Argument 'attr' missing";
	
	var result%function:value = "{this%attr_value_{arg%node}:{arg%attr}}";
	var result%function:namespace = "{this%attr_namespace_{arg%node}:{arg%attr}}";
	var result%function:localpart = "{this%attr_localpart_{arg%node}:{arg%attr}}";
	var result%function:prefix = "{this%attr_prefix_{arg%node}:{arg%attr}}";
}


/************************************************************
 *	xml_getattrlist: Get all attribute indexes of node {arg%node}
 *		(default is this%root).
 *
 *	arg%node - the node index (default is {this%root})
 *	result%function - names of attributes (literally as specified
 *		in the XML Doc) of the node
 ************************************************************/

function xml_getattrlist
{
	if ({arg%function:node|isset} == 0) var arg%node = "{this%root}";
	var result%function = "(var)this%attr_value_{arg%node}" conv="keys";
}
</script>
