<?php include("bee/compiler.php"); return; ?>
<script language="bee">

/************************************************************
 *	Attributes
 ************************************************************/

/************************************************************
 *	xml_attributes: Return an array containing the attributes of the node
 *
 *	arg%node - the node of which the attributes are returned (default this%root)
 *	arg%keyformat - the format of the "key".  Default is @localpart. (note)
 *	arg%valueformat - the format of the "value".  Default is @value. (note)
 *	result%function - the array of all attributes of the node
 *
 *	Note: Inside the keyformat and valueformat, the name of the content
 *		should be prefixed by a '@'.  For example, if you want to have
 *		the value of "namespace" followed ':' and the value of "localpart"
 *		attribute as the key, set arg%keyformat to "@namespace:@localpart".
 ************************************************************/

function xml_attributes keyformat="@localpart" valueformat="@value"
{
	var node = "{arg%node}";
	if ({arg%function:node|isset} == 0) var node = "{this%root}";

	this%xml_getattrlist node="{node}";
	foreach (this%xml_getattrlist as attr) {
		var attrkey = "{arg%keyformat}";
		var attrvalue = "{arg%valueformat}";
		foreach ((array)value,namespace,localpart,prefix) {
			var attrkey = "{attrkey|replace:@{foreach},{this%attr_{foreach}_{node}:{attr}}}";
			var attrvalue = "{attrvalue|replace:@{foreach},{this%attr_{foreach}_{node}:{attr}}}";
			var result%function:{attrkey} = "{attrvalue}";
		}
	}
}

/************************************************************
 *	xml_nodes: Return an array containing the nodes one level down {arg%node}
 *
 *	arg%node - the node of which the nodes are returned (default this%root)
 *	arg%keyformat - the format of the "key".  Default is @localpart. (note)
 *	arg%valueformat - the format of the "value".  Default is @value. (note)
 *	result%function - the array of all children of the node
 *
 *	Note: Inside the keyformat and valueformat, the name of the content
 *		should be prefixed by a '@'.  For example, if you want to have
 *		the value of "namespace" followed ':' and the value of "tag"
 *		attribute as the key, set arg%keyattr to "@namespace:@tag".
 ************************************************************/

function xml_nodes keyformat="@localpart" valueformat="@value"
{
	var node = "{arg%node}";
	if ({arg%function:node|isset} == 0) var node = "{this%root}";

	this%tree_children node="{node}";
	foreach (this%tree_children as node) {
		var nodekey = "{arg%keyformat}";
		var nodevalue = "{arg%valueformat}";
		foreach (this%xml_{node}) {
			var nodekey = "{nodekey|replace:@{foreach:key},{foreach}}";
			var nodevalue = "{nodevalue|replace:@{foreach:key},{foreach}}";
			var result%function:{nodekey} = "{nodevalue}";
		}
	}
}
</script>
