<?php include("bee/compiler.php"); return; ?>
<script language="bee">

/************************************************************
 *	xml_setstruct: Set the supportive structure for the XML Object
 *		(Recursive algorithm)
 *
 *	arg%node - the subtree to set structure
 *	arg%namespace - the namespace array
 *	arg%eldersns - the elder's namespace array for nodes of type "cdata" and "close"
 *	result%function - the namespace array extended with the
 *		namespace declarations of {arg%node}
 ************************************************************/

function xml_setstruct
{
	if ({arg%function:node|isset} == 0) return status=1 message="Argument 'node' missing";
	var node = "{arg%node}";

	var namespace = "(var)arg%namespace";

	// Don't quit ... for the sake of the children!  (sob ...)
	if ({this%xml_{node}|isset}) {
		// Namespace declaration
		if (!{this%turbo}) {
			foreach (this%attr_value_{node} as attr) {
				if ('{attr:key}' == 'xmlns') {
					// Default namespace with null prefix
					var namespace = "{attr}";
				} else if ({attr:key|foundre:^xmlns:}) {
					var namespace:{attr:key|replacere:^xmlns:} = "{attr}";
				}
			}
		} else {
</script>
<?php
			$namespace =& BEE_var("namespace");
			$arr = BEE_get("(var)this%attr_value_{node}");
			foreach ($arr as $attrKey => $attr) {
				if ($attrKey == 'xmlns') {
					$namespace[""] = $attr;
				} else if (ereg("^xmlns:", $attrKey)) {
					$namespace[ereg_replace("^xmlns:", "", $attrKey)] = $attr;
				}
			}
?>
<script language="bee">
		}

		switch ('{this%xml_{node}:type}') {
		case 'cdata':
		case 'close':
			if ({#arg%eldersns}) {
				// If there're duplicated prefix, the one in eldersns will be used
				var namespace = "(var)namespace" conv="merge:(var)arg%eldersns";
			}
			break;
		}

		// Namespace for attributes
		if (!{this%turbo}) {
			foreach (this%attr_value_{node} as attr) {
				this%xml_xltns name="{attr:key}" namespace="(var)namespace" attrns=1;
				var this%attr_namespace_{node}:{attr:key} = "{result%xml_xltns:namespace}";
				var this%attr_localpart_{node}:{attr:key} = "{result%xml_xltns:localpart}";
				var this%attr_prefix_{node}:{attr:key} = "{result%xml_xltns:prefix}";
			}
		} else {
</script>
<?php
			$arr = BEE_get("(var)this%attr_value_{node}");
			foreach ($arr as $attrKey => $attr) {
				$param = array();
				$param["name"] = $attrKey;
				$param["namespace"] = "(var)namespace";
				$param["attrns"] = "1";
				$param["this"] = "this";
				BEE_do("xml_xltns");
				$resultXltNS =& BEE_var("result%xml_xltns");
				BEE_set("this%attr_namespace_{node}:" . $attrKey, $resultXltNS["namespace"]);
				BEE_set("this%attr_localpart_{node}:" . $attrKey, $resultXltNS["localpart"]);
				BEE_set("this%attr_prefix_{node}:" . $attrKey, $resultXltNS["prefix"]);
			}
?>
<script language="bee">
		}

		// Namespace for {node} itself
		this%xml_xltns name="{this%xml_{node}:tag}" namespace="(var)namespace";
		var this%xml_{node}:namespace = "{result%xml_xltns:namespace}";
		var this%xml_{node}:localpart = "{result%xml_xltns:localpart}";
		var this%xml_{node}:prefix = "{result%xml_xltns:prefix}";
	}

	// Children now
	this%tree_children node="{node}";
	if ({status%tree_children})
		return status="{status%tree_children}" message="{message%tree_children}";

	// Recursive
	var myEldersNS = "(array)";
	if (!{this%turbo}) {
		foreach (result%tree_children as child) {
			this%xml_setstruct node="{child}" namespace="(var)namespace" eldersns="(var)myEldersNS";
			var myEldersNS = "(var)result%xml_setstruct";
		}
	} else {
</script>
<?php
		$myEldersNS =& BEE_var("myEldersNS");
		$arr = BEE_get("(var)result%tree_children");
		foreach ($arr as $child) {
			$param = array();
			$param["node"] = $child;
			$param["namespace"] = "(var)namespace";
			$param["eldersns"] = "(var)myEldersNS";
			$param["this"] = "this";
			BEE_set("param%xml_setstruct", $param);
			BEE_do("xml_setstruct");
			$myEldersNS = BEE_get("(var)result%xml_setstruct");
		}
?>
<script language="bee">
	}

	var result%function = "(var)namespace";
}


/************************************************************
 *	xml_xltns: Translate Namesapce (private use for xml_setstruct)
 *
 *	arg%name - the name to translate
 *	arg%namespace - the namespace array
 *	arg%attrns - if non-zero, take it as an attribute namespace
 *		so no default namespace (null prefix) is used.  Default is 0.
 ************************************************************/

function xml_xltns attrns=0
{
	var localpart = "{arg%name}";
	var prefix = "";
	var reg = "{localpart}" conv="match:^(.*):(.*)$";
	if ({#reg}) {
		var localpart = "{reg:#2}";
		var prefix = "{reg:#1}";
	}
	var ns = "{prefix}";

	if ({arg%attrns} == 0 || "{prefix}" != "")
		if ({arg%namespace:{prefix}|isset})
			var ns = "{arg%namespace:{prefix}}";

	if ({arg%attrns} && "{prefix}" == "xmlns") var ns = "";

	var result%function:namespace = "{ns}";
	var result%function:localpart = "{localpart}";
	var result%function:prefix = "{prefix}";
}
</script>
