<?php include("bee/compiler.php"); return; ?>
<script language="bee">

/************************************************************
 *	xml_xmldoc: Return the XML document (Recursive algorithm)
 *
 *	arg%node - a subtree under {arg%node} (default is {this%root})
 *	arg%html - if non-zero, return the XML in HTML displable
 *		format with proper spacing for level indent.  Default is 0.
 *	arg%ignorecdata - if non-zero, all cdata will be ignored.  Default is 0.
 *	arg%level - indentation (for internal recursive call only.
 *		Default is -1, as we know the top level is dummy.)
 ************************************************************/

function xml_xmldoc html=0 ignorecdata=0 level=-1
{
	var node = "{arg%node}";
	if ({arg%function:node|isset} == 0) var node = "{this%root}";

	var tab = "  ";
	var lt = "<";
	var gt = ">";
	var br = "\n";
	var cdataconv = "";

	if ({arg%html}) {
		var tab = "&nbsp;&nbsp;&nbsp;&nbsp;";
		var lt = "&lt;";
		var gt = "&gt;";
		var br = "<br>\n";
		var cdataconv = "replace:\ ,&nbsp;";
	}

	var level = "{arg%level}";

	this%xml_getnode node="{node}";
	if ({status%xml_getnode})
		return status="{status%xml_getnode}" message="{message%xml_getnode}";

	// Don't quit ... for the sake of the children!  (sob ...)
	if ({#result%xml_getnode}) {
		var tag = "{result%xml_getnode:tag}";
		var type = "{result%xml_getnode:type}";
		var value = "{result%xml_getnode:value}";
		var attr = '{this%attr_value_{node}|list:( @key="@value")()}';

		var indent = '';
		if ({level} > 0) var indent = "{tab}" conv="repeat:{level}";

		var result%function = "";
	
		switch ("{type}") {
		case "open":
			var result%function = "{result%function}{indent}{lt}{tag}{attr}{gt}{value}{br}";
			break;
		case "complete":
			var result%function = "{result%function}{indent}{lt}{tag}{attr}{gt}{value}{lt}/{tag}{gt}{br}";
			break;
		case "cdata":
			if ({arg%ignorecdata} == 0) var result%function = "{result%function}{value}" conv="{cdataconv}";
			break;
		case "close":
			var result%function = "{result%function}{indent}{lt}/{tag}{gt}{br}";
			break;
		default:
			var result%function = '{result%function}{indent}{lt}error message="Illegal type \'{type}\' for {tag}"/{gt}{br}';
			break;
		}
	}

	// Dump children now
	var nextLevel = "{level|inc}";
	this%tree_children node="{node}";
	foreach (result%tree_children) {
		this%xml_xmldoc node="{foreach}" level="{nextLevel}"
			html="{arg%html}" ignorecdata="{arg%ignorecdata}";
		if ({status%xml_xmldoc} == 0)
			var result%function = "{result%function}{result%xml_xmldoc}";
	}
}
</script>
