<?php include("bee/compiler.php"); return; ?>
<script language="bee">
PortalObjectVersion = "1.2.1";

// The portal object
// The portal IS an dbobj for the purpose of the menu
include "common/dbobj.bs";
include "portal{PortalObjectVersion}/portal_cach.bs";
include "portal{PortalObjectVersion}/portal_sect.bs";
include "portal{PortalObjectVersion}/portal_proc.bs";
include "portal{PortalObjectVersion}/portal_menu.bs";
include "portal{PortalObjectVersion}/portal_mref.bs";
include "portal{PortalObjectVersion}/portal_util.bs";
include "portal{PortalObjectVersion}/tbody.bs";

/* Scheme settings in the Portal Object
MenuName
MenuTable
MenuType
MenuModel
PageHeadingName
PageBodyName
TextItem
PageTarget
SessionTimeout
IdleTimeout
EasyNew
EasyCopy
BuildListMenu
BuildPathMenu
BuildPageBar
SiteFace
Settings
SettingsConfig
ListMenuFormat
ListMenuButton
PathMenuFormat
Subpath
TextSubdir
RawPP
Cache
NoCache
Phantom
DirectoryIndex
 */

function portal
{
	/*
	Definitions (under this context):
	--------------------------------
	"PathPage" (PP) stands for the URL without the leading protocol and web server.
	e.g. in http://bee.onmyweb.net/path/page.htm "PathPage" is "/path/page.htm".

	"Subpath" stands for a leading path in PathPage which all references are either
	relative to (as in text%) or situated under (in case of full path).

	"Subpage" (SP) is the "PathPage" with the leading "Subpath" stripped.
	e.g. in http://bee.onmyweb.net/path/mypath/page.htm, if "Subpath" is "/path",
	then "Subpage" "/mypath/page.htm".

	"Entry" is the Page name (PP or SP) with the page number part stripped.
	e.g. if the page is /mypath/page_2.htm, its "Entry" is "/mypath/page.htm".
	(This is the page specified in the Menu, hence the name "Entry".)

	"Family" is the Entry (PP or SP) with the extention stripped.
	e.g. if the page name is /mypath/page_2.htm, its "Family" is "/mypath/page".

	Menu structure:
	--------------
	Menu (contained in this%MenuName) is a global dbobj.  It contains at least
	the following fields:
		Topic		A unique handle to the menu item
		Parent		The "Topic" of the parent item (blank for top level items)
		Name		The topic name
		Description	The topic description (usually one line)
		Page		The "Subpage" to the web page
		Param		A parameter string (subject to interpretation by the web page)
		AccessLevel	Minimum access level (numeric) required to access the web page
	Other fields can be added; they will not be processed but will appear in the
	PageInfo JavaScript array.
	 */

	global PortalObjectVersion;
	this%PortalObjectVersion = "{PortalObjectVersion}";

	// ---------- Functions ----------

	// portal_cach.bs
	this%function:readCache = portal_readCache;
	this%function:writeCache = portal_writeCache;
	this%function:clearCache = portal_clearCache;
	this%function:text = portal_text;
	this%function:schm = portal_schm;
	this%function:savePhantomMenu = portal_savePhantomMenu;

	// portal_sect.bs
	this%function:prelude = portal_prelude;
	this%function:head = portal_head;
	this%function:body = portal_body;
	this%function:application = portal_application;
	this%function:adminmenu = portal_adminmenu;
	this%function:usermenu = portal_usermenu;
	this%function:setGlobalVars = portal_setGlobalVars;
	// Obsolete names
	this%function:clientScripts = portal_clientScripts;  // Now portal_body

	// portal_proc.bs
	this%function:pathPage = portal_pathPage;
	this%function:auth = portal_auth;

	// portal_menu.bs
	this%function:menuLoad = portal_menuLoad;
	this%function:menuItemsJS = portal_menuItemsJS;
	this%function:showMenuItemsJS = portal_showMenuItemsJS;
	this%function:pageBar = portal_pageBar;
	this%function:numMenuItems = portal_numMenuItems;

	// portal_mref.bs
	this%function:menuSelectOptionTags = portal_menuSelectOptionTags;
	this%function:listMenu = portal_listMenu;
	this%function:pathMenu = portal_pathMenu;
	this%function:menuRefresh = portal_menuRefresh;

	// portal_util.bs
	this%function:parsePageName = portal_parsePageName;
	this%function:genPageName = portal_genPageName;
	this%function:convPath = portal_convPath;
	this%function:convPN = portal_convPN;
	this%function:valueQuote = portal_valueQuote;

	// ---------- Definitions ----------

	this%PageSyntax = "^(([^_]+)(_[^[:digit:]_][^_]*)*)(_([[:digit:]]+))?(\..*)$";
	this%PageSyntax:family = 1;
	this%PageSyntax:pagenum = 5;
	this%PageSyntax:pageext = 6;

	this%PageSyntaxAlt = "^(([^_]+)(_[^[:digit:]_][^_]*)*)(_([[:digit:]]+))*$";
	this%PageSyntaxAlt:family = 1;
	this%PageSyntaxAlt:pagenum = 5;
	this%PageSyntaxAlt:pageext = 6;

	// ---------- Data ----------

	// Web Cell behaviour
	this%Cell = "{arg%Cell}";
	if ({#this%Cell:} == 0) this%Cell = "{scheme%portal&Cell}";
	if ({#this%Cell:} == 0) this%Cell = 0;

	this%CellCachePath = '';
	this%JSBegin = '\n<scr';
	this%JSBegin = '{this%JSBegin}ipt language="JavaScript">\n';
	this%JSEnd = '\n</scr';
	this%JSEnd = '{this%JSEnd}ipt>\n';
	if ('{this%Cell}') {
		this%CellCachePath = '/Cell';
		switch ('{this%Cell|lowercase}') {
		case 'nojs':
			this%JSBegin = '\n<!--\n';
			this%JSEnd = '\n-->\n';
			break;
		case 'withjs':
			break;
		default:
			this%JSBegin = '';
			this%JSEnd = '';
			break;
		}
	}

	// The site name
	this%SiteName = "{arg%SiteName}";
	if ({#this%SiteName:} == 0) this%SiteName = "{scheme%SiteName}";
	if ({#this%SiteName:} == 0) this%SiteName = "Portal";

	// The site URL
	this%SiteURL = "{arg%SiteURL}";
	if ({#this%SiteURL:} == 0) this%SiteURL = "{scheme%SiteURL}";
	//if ({#this%SiteURL:} == 0) this%SiteURL = "{sys%url:server}";
	if ({#this%SiteURL:} == 0) this%SiteURL = "http://{sys%croft:webserver}{sys%croft:webpath}";
	this%SiteURL = "{this%SiteURL|this%convPath:,/}";

	this%VirtualPage = "{arg%VirtualPage}";
	if ({#this%VirtualPage:} == 0) this%VirtualPage = "{scheme%portal&VirtualPage}";
	if ({#this%VirtualPage:} == 0) this%VirtualPage = "{this%SiteURL}";

	// The name of the VirtualBase (VB) where the menu is in
	this%MenuName = "{arg%MenuName}";
	if ({#this%MenuName:} == 0) this%MenuName = "{scheme%portal&MenuName}";
	if ({#this%MenuName:} == 0) this%MenuName = "Menu";

	// The name of the VirtualBase (VB) table that holds the menu items
	this%MenuTable = "{arg%MenuTable}";
	if ({#this%MenuTable:} == 0) this%MenuTable = "{scheme%portal&MenuTable}";
	if ({#this%MenuTable:} == 0) this%MenuTable = "Menu";

	// The type of menu data: VB (default), DB (Database) and CSV (Comma-Separated-Values)
	this%MenuType = "{arg%MenuType}";
	if ({#this%MenuType:} == 0) this%MenuType = "{scheme%portal&MenuType}";
	if ({#this%MenuType:} == 0) this%MenuType = "VB";

	// The menu model
	//	Page (default) - using the URL to determine the menu item
	//	Action - using a unique handle to identify the menu item (usually interactively)
	//this%MenuModel = "{arg%MenuModel}";
	//if ({#this%MenuModel:} == 0) this%MenuModel = "{scheme%portal&MenuModel}";
	//if ({#this%MenuModel:} == 0) this%MenuModel = "Page";

	// The name of the TEAs in a page
	// (text%{this%PageHeading} is used to detect the existance of a page.)
	this%PageHeadingName = "{arg%PageHeadingName}";
	if ({#this%PageHeadingName:} == 0) this%PageHeadingName = "{scheme%portal&PageHeadingName}";
	if ({#this%PageHeadingName:} == 0) this%PageHeadingName = "PageHeading";

	this%PageBodyName = "{arg%PageBodyName}";
	if ({#this%PageBodyName:} == 0) this%PageBodyName = "{scheme%portal&PageBodyName}";
	if ({#this%PageBodyName:} == 0) this%PageBodyName = "PageBody";

	this%TextItem = "{arg%TextItem}";
	if ({#this%TextItem:} == 0) this%TextItem = "{scheme%portal&TextItem}";

	// The target frame where the page is loaded
	this%PageTarget = "{arg%PageTarget}";
	if ({#this%PageTarget:} == 0) this%PageTarget = "{scheme%portal&PageTarget}";
	if ({#this%PageTarget:} == 0) this%PageTarget = "_top";

	// The Target Object for JavaScript
	this%PageTargetObject = "window";
	if ('{this%PageTarget}' != '_top')
		this%PageTargetObject = "document.frames.parent.{this%PageTarget}";

	// The session data
	this%SessionTimeout = "{arg%SessionTimeout}";
	if ({#this%SessionTimeout:} == 0) this%SessionTimeout = "{scheme%portal&SessionTimeout}";
	this%IdleTimeout = "{arg%IdleTimeout}";
	if ({#this%IdleTimeout:} == 0) this%IdleTimeout = "{scheme%portal&IdleTimeout}";

	// Features
	this%EasyNew = "{arg%EasyNew}";
	if ({#this%EasyNew:} == 0) this%EasyNew = "{scheme%portal&EasyNew}";
	if ({#this%EasyNew:} == 0) this%EasyNew = 0;

	this%EasyCopy = "{arg%EasyCopy}";
	if ({#this%EasyCopy:} == 0) this%EasyCopy = "{scheme%portal&EasyCopy}";
	if ({#this%EasyCopy:} == 0) this%EasyCopy = 0;

	this%BuildListMenu = "{arg%BuildListMenu}";
	if ({#this%BuildListMenu:} == 0) this%BuildListMenu = "{scheme%portal&BuildListMenu}";
	if ({#this%BuildListMenu:} == 0) this%BuildListMenu = 0;

	this%BuildPathMenu = "{arg%BuildPathMenu}";
	if ({#this%BuildPathMenu:} == 0) this%BuildPathMenu = "{scheme%portal&BuildPathMenu}";
	if ({#this%BuildPathMenu:} == 0) this%BuildPathMenu = 0;

	this%BuildPageBar = "{arg%BuildPageBar}";
	if ({#this%BuildPageBar:} == 0) this%BuildPageBar = "{scheme%portal&BuildPageBar}";
	if ({#this%BuildPageBar:} == 0) this%BuildPageBar = 0;

	this%SiteFace = "{arg%SiteFace}";
	if ({#this%SiteFace:} == 0) this%SiteFace = "{scheme%portal&SiteFace}";
	if ({#this%SiteFace:} == 0) this%SiteFace = "";

	this%Settings = "{arg%Settings}";
	if ({#this%Settings:} == 0) this%Settings = "{scheme%portal&Settings}";
	if ({#this%Settings:} == 0) this%Settings = "settings";

	this%SettingsConfig = "{arg%SettingsConfig}";
	if ({#this%SettingsConfig:} == 0) this%SettingsConfig = "{scheme%portal&SettingsConfig}";
	if ({#this%SettingsConfig:} == 0) this%SettingsConfig = "settings.conf";

	// Application

	this%InApplication = 0;
	this%GlobalVarsSet = 0;
	this%PreludeName = "";
	this%ApplicationSP = "";
	this%ApplicationInclude = "";
	this%ApplicationName = "";
	this%SubmitRedirected = 0;
	this%PageAccessible = 1;

	// Menu Formating

	// The ListMenu format
	this%ListMenuFormat = (var)arg%ListMenuFormat;
	if ({#this%ListMenuFormat:} == 0) this%ListMenuFormat = (var)scheme%portal&ListMenuFormat;

	this%ListMenuButton = (var)arg%ListMenuButton;
	if ({#this%ListMenuButton:} == 0) this%ListMenuButton = (var)scheme%portal&ListMenuButton;

	if ({#this%ListMenuButton:Item} == 0)
		this%ListMenuButton:Item = " o ";
	if ({#this%ListMenuButton:ItemActive} == 0)
		this%ListMenuButton:ItemActive = " <font color=#ff0000>o</font> ";
	if ({#this%ListMenuButton:Menu} == 0)
		this%ListMenuButton:Menu = " &gt; ";
	if ({#this%ListMenuButton:MenuOpened} == 0)
		this%ListMenuButton:MenuOpened = " v ";
	if ({#this%ListMenuButton:MenuActive} == 0)
		this%ListMenuButton:MenuActive = " <font color=#ff0000>v</font> ";

	// The PathMenu format
	this%PathMenuFormat = (var)arg%PathMenuFormat;
	if ({#this%PathMenuFormat:} == 0) this%PathMenuFormat = (var)scheme%portal&PathMenuFormat;

	// Action Menus
	//this%ActionMenus = (array);

	// PageBar requires ListMenu; otherwise, the chapter arrows will not show
	//if ('{#this%BuildPageBar}') this%BuildListMenu = 1;

	// The Subpath (optional)
	this%Subpath = "{arg%Subpath}";
	if ({#this%Subpath:} == 0) this%Subpath = "{scheme%portal&Subpath}";
	if ({#this%Subpath:} == 0) this%Subpath = "{sys%croft:webpath}";
	if ('{this%Subpath}' == '/') this%Subpath = "";
	else this%Subpath = "{this%Subpath|this%convPath}";

	this%rt = "{sys%croft:webpath}/" conv="replacere:/+,/";
	this%IncludeRoot = "{this%Subpath|this%convPath:,/}";

	// TextSubdir
	this%TextSubdir = "{arg%TextSubdir}";
	if ({#this%TextSubdir:} == 0) this%TextSubdir = "{scheme%portal&TextSubdir}";
	if ('{this%TextSubdir}' == '/') this%TextSubdir = "";
	else this%TextSubdir = "{this%TextSubdir|this%convPath}";

	// DefaultText and DefaultTextPage
	this%DefaultText = "{arg%DefaultText}";
	if ({#this%DefaultText:} == 0) this%DefaultText = "{scheme%portal&DefaultText}";
	this%DefaultTextPage = "";
	if ({#this%DefaultText:} == 0) {
		// Found the DefaultTextPage
		this%DefaultTextPage = "{arg%DefaultTextPage}";
		if ({#this%DefaultTextPage:} == 0) this%DefaultTextPage = "{scheme%portal&DefaultTextPage}";
		if ({#this%DefaultTextPage:} == 0) this%DefaultTextPage = "/notfound.htm";
		// The following calls %text and therefore requires Subpath, TextSubdir,
		// PP, DirectoryIndex, Phantom, PageBodyName, TextItem
		this%text "{this%DefaultTextPage}&{this%PageBodyName}:{this%TextItem}" phantomget="text";
		this%DefaultText = "{result%text}";
	}
	if ({#this%DefaultText:} == 0) this%DefaultText = '<span class="error">Page not found or under construction</span>';

	// Text Parameters
	this%TextParam = "(var)arg%TextParam";
	if ({#this%TextParam} == 0) this%TextParam = "(var)scheme%portal&TextParam";

	// Default Page Extention
	this%DefaultPageExt = "{arg%DefaultPageExt}";
	if ({#this%DefaultPageExt:} == 0) this%DefaultPageExt = "{scheme%portal&DefaultPageExt}";
	if ({#this%DefaultPageExt:} == 0) this%DefaultPageExt = ".htm";

	// Raw PathPage (no convPath to allow trailing /)
	this%RawPP = "{arg%RawPP}";
	if ({#this%RawPP:} == 0) this%RawPP = "{scheme%portal&RawPP}";
	if ({#this%RawPP:} == 0) this%RawPP = 0;

	// Which field in the VB holds the Subpage
	//this%PageField = "Page";
	//if ('{this%MenuModel}' == 'Page') this%PageField = "Address";

	// Cache
	this%Cache = "{arg%Cache}";
	if ({#this%Cache:} == 0) this%Cache = "{scheme%portal&Cache}";
	if ({#this%Cache:} == 0) this%Cache = "cache";

	this%CacheNames = (var)scheme%{this%Cache}.index&Name;
	if ({#this%CacheNames} == 0)
		this%CacheNames = "(array)MenuSelectOptionTags:Page,MenuSelectOptionTags:Topic,MenuItemsJS";

	this%CacheAccessLevels = (var)scheme%{this%Cache}.index&AccessLevel;
	if ({#this%CacheAccessLevels} == 0)
		this%CacheAccessLevels = "(array)0,1,2,3,4,5,6,7,8,9,10";

	// NoCache needs to be before Phantom as Phantom implies/overwrites NoCache
	this%NoCache = "{arg%NoCache}";
	if ({#this%NoCache:} == 0) this%NoCache = "{scheme%portal&NoCache}";
	if ({#this%NoCache:} == 0) this%NoCache = 0;

	// No Cache: A comma delimited cache names not to be cached
	/*
	this%NoCache = "{arg%NoCache}";
	if ({#this%NoCache:} == 0) this%NoCache = "{scheme%portal&NoCache}";
	if ({#this%NoCache:}) {
		this%NoCache = "(array){this%NoCache}" conv="inverse";
		this%NoCache = (var)this%NoCache conv="setvalue:1";
	}
	 */

	// Phantom
	this%Phantom = "{arg%Phantom}";
	if ({#this%Phantom:} == 0) this%Phantom = "{scheme%portal&Phantom}";
	if ({#this%Phantom:} == 0) this%Phantom = 0;
	session%Phantom = "{this%Phantom}";
	if (!'{this%Phantom}') {
		clear session%Phantom_Text;
		clear session%Phantom_Menu_CreateTable;
		clear session%Phantom_Menu_InsertInto;
		clear session%Phantom_Scheme;
		// session%tbody_ ... needs to be cleared too but later
	}

	if ('{this%Phantom}') this%NoCache = 1;

	// Initialise (must be in order)
	this%pathPage;

	// If any applications "dare" to change %PP or %SP,
	// at least we have a copy in %PPOriginal and %SPOriginal
	this%PPOriginal = "{this%PP}";
	this%SPOriginal = "{this%SP}";

	this%auth;  // Must come before menuLoad as menuLoad determine PageAccessible
	this%menuLoad;
	this%readCache;  // Read the cache only after auth
	this%menuRefresh;
	this%pageBar;
}
</script>
